
/*************************************************************/
/* Do all the output for the electomagnic analysis.          */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29may87 */ 

#include "local.h"
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "em.typ"
#include <ctype.h>

char *strcat();
void free();
extern char *get_version();
extern char *get_license_id();
extern char *get_node_id();
extern char prog_name[];

static char *dbed_file,*ndbed_file,*comment;

Init_rsp_file( argc,argv,Box,C0,An,Fmt ) int argc; char *argv[]; Box_info *Box;
				 Cir *C0; An_info *An; Fmt_info *Fmt;
/*************************************************************/
/* Do all the output for the electomagnic analysis.          */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr05aug92 */ 
{ int mem_needed,sum;
  long clock=1;
  long time();
  FILE *out;

  comment = Fmt->Com;  /*Global*/

  if (Fmt->spice)
    init_spice_file(argc,argv,Box,C0,An,Fmt);

  if (Fmt->ndbed)
  { ndbed_file = Fmt->ndbed_file;  /*Global*/
    Init_sparm_file(argc,argv,Box,C0,An,Fmt,0);
  }
  else
    ndbed_file = NULL;

  if (Fmt->dbed)
  { dbed_file = Fmt->dbed_file;  /*Global*/
    Init_sparm_file(argc,argv,Box,C0,An,Fmt,1);
  }
  else
    dbed_file = NULL;

  /*Append a warning to cir.rsp, if cir.rsp exists and is not used*/
  if (
       (  ( ndbed_file && strcmp(ndbed_file,"cir.rsp") != 0 ) ||
          ( dbed_file  && strcmp(dbed_file,"cir.rsp") != 0  )    ) &&

          ( out=fopen("cir.rsp","r")) != NULL /*file exist?*/           )

  { fclose(out);
    out = fopen("cir.rsp","a");
    if ( out != NULL )
    { fprintf(out,"%s **** Look at",Fmt->Com);
      if (ndbed_file) fprintf(out," %s",ndbed_file);
      if (ndbed_file && dbed_file) fprintf(out," and");
      if (dbed_file) fprintf(out," %s",dbed_file);
      fprintf(out," for result -- ");
      time(&clock);
      fprintf(out,"%s",ctime(&clock));
      fclose(out);
    }
  }

  em_mem_calc(C0,Box,An,&mem_needed,&sum);
  if ( An->State )
  {  printf("Circuit uses %d subsections, %d Mbyte",sum,mem_needed);
     if (mem_needed>1) printf("s");
     printf(".\n");
  }
  check_sub_limit(sum,stderr,Fmt->Com);

} /*Init_rsp_file*/

Init_sparm_file( argc,argv,Box,C0,An,Fmt,dbed ) int argc; char *argv[]; Box_info *Box;
				 Cir *C0; An_info *An; Fmt_info *Fmt;  int dbed;
/*************************************************************/
/* Initialize sparameter output files.                       */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr02jun87 */ 
{ FILE *out;
  int i,sum;
  long clock=1;
  long time();
  char str[10];
  Met_type *Mp;
  Rtyp rp,xp,lp,cp;
  extern int print_license_warning;

  if (dbed)
  { if ( (out=fopen(dbed_file,"a")) == NULL )
    { fprintf(stderr,"\n%s: Unable to open de-embedded data file -- %s --\n",
						  prog_name,dbed_file);
      return(-1);
    }
  }
  else
  {
    if ( (out=fopen(ndbed_file,"a")) == NULL )
    { fprintf(stderr,"\n%s: Unable to open non-de-embedded data file -- %s --\n",
						  prog_name,ndbed_file);
      return(-1);
    }
  }

  /*Output the command line*/
  if (Fmt->Cvend == 'S') fprintf(out," MIDAS/\nTABULATED : %s\n",Fmt->cir_name);
  fprintf(out,"%s\n%s **************************************************\n",
	       comment,comment);
  subsection_warning(out,Fmt->Com,print_license_warning);
  subsection_warning(stdout,"",print_license_warning);

  /*Do date and time next*/
  time(&clock);
  fprintf(out,"%s ",comment);
  for (i=0; i<argc; i++) fprintf(out,"%s ",argv[i]);
  fprintf(out,"-- %s",ctime(&clock));
  fprintf(out,"%s em %s, id %s, on %s.\n",
	      comment,get_version(),get_license_id(),get_node_id());
  fprintf(out,"%s Last time %s was updated - %s\n",comment,Box->file,Box->xgeomdate);
  Do_ann( out,Box->ann,Box->num_ann,comment );
  Do_ann( out,An->ann,An->num_ann,comment );
  if (An->Mem_saver) fprintf(out,"%s Memory saver option enabled.\n",comment);

  if ( sizeof(RRtyp) > sizeof(Rtyp) ) /*Check to make sure quad provides adavantage*/
  { if ( Box->quad_prec )
      fprintf(out,"%s Quad precision enabled.\n",comment);
    else if ( *An->Freq < Box->qfmin )
      fprintf(out,"%s Quad precision, '-q', automatically enabled below %.3lf MHz.\n",
        comment,Box->qfmin);
  }
  else if (Box->quad_prec)
    fprintf(out,"%s ***WARNING*** The '-q' option has no effect on this computer.\n",comment);

  fprintf(out,"%s %d subs/wavelength at ",comment,Box->msub_per);
  if ( An->Funit == 'G' )
    fprintf(out,"%lf GHz.\n",0.001 * An->fmax);
  else
    fprintf(out,"%lf MHz.\n",An->fmax);
  fprintf(out,"%s All dimensions are in %s.\n",comment,Box->Lstr);
  fprintf(out,"%s   A = %lf(%d), B = %lf(%d), C = %lf, with %d layers.\n",comment,
			     Box->A/Box->Lcnv,Box->Capm/2,Box->B/Box->Lcnv,Box->Capn/2,Box->C/Box->Lcnv,C0->n);
  fprintf(out,
    "%s   Layer  H(%5s)      Erel    tan(d)     Murel    tan(d)  subs\n"
    ,comment,Box->Lstr);
  sum = 0;
  for (i=0; i<=Box->Num_levels; i++)
  { fmtr(str,9,*(Box->H+i)/Box->Lcnv); fprintf(out,"%s     %d    %s",comment,i,str);
    fmtr(str,9,*(Box->Eps+i)/EPSILON_0);  fprintf(out,"  %s",str);
    fmtr(str,9,*(Box->Eloss+i));  fprintf(out,"  %s",str);
    fmtr(str,9,*(Box->Mu+i)/MU_0);  fprintf(out,"  %s",str);
    fmtr(str,9,*(Box->Mloss+i));  fprintf(out,"  %s",str);
    fprintf(out,"  %d",(C0->lev0+i)->n);
    fprintf(out,"\n");
    sum += (C0->lev0+i)->n;
  }

  check_sub_limit(sum,out,Fmt->Com);

  /*Do metalization losses*/
  if ( Box->num_met > 0 ||
       fabs(Box->Top.rdc)+fabs(Box->Top.rrf)+fabs(Box->Bot.rdc)+fabs(Box->Bot.rrf)+
            fabs(Box->Top.xdc)+fabs(Box->Bot.xdc) > 1.0e-30)
    fprintf(out,"%s Metalization Losses (Ohms/square)\n",comment);
  if (fabs(Box->Top.rdc)+fabs(Box->Top.rrf)+fabs(Box->Top.xdc) > 1.0e-30)
  { fprintf(out,"%s   %-12s --",comment,Box->Top.name);
    fprintf(out," %lg(DC)",Box->Top.rdc);
    fprintf(out,",%lg*sqrt(F)",Box->Top.rrf);
    if (Box->Top.xdc>1.0e-30) fprintf(out," + j %lg (DC)",Box->Top.xdc);
    if (Box->Top.xdc<1.0e-30) fprintf(out," - j %lg (DC)",fabs(Box->Top.xdc));
    fprintf(out,"\n");
  }
  if (fabs(Box->Bot.rdc)+fabs(Box->Bot.rrf)+fabs(Box->Bot.xdc) > 1.0e-30)
  { fprintf(out,"%s   %-12s --",comment,Box->Bot.name);
    fprintf(out," %lg(DC)",Box->Bot.rdc);
    fprintf(out,",%lg*sqrt(F)",Box->Bot.rrf);
    if (Box->Bot.xdc>1.0e-30) fprintf(out," + j %lg (DC)",Box->Bot.xdc);
    if (Box->Bot.xdc<1.0e-30) fprintf(out," - j %lg (DC)",-(Box->Bot.xdc));
    fprintf(out,"\n");
  }
  if (Box->num_met>0) for (Mp=Box->met; Mp<Box->met+Box->num_met; Mp++)
  { fprintf(out,"%s   %-12s --",comment,Mp->name);
    fprintf(out," %lg(DC)",Mp->rdc);
    fprintf(out,",%lg*sqrt(F)",Mp->rrf);
    if (Mp->xdc>1.0e-30) fprintf(out," + j %lg (DC)",Mp->xdc);
    if (Mp->xdc < -1.0e-30) fprintf(out," - j %lg (DC)",-(Mp->xdc));
    fprintf(out,"\n");
  }

  if (Box->Xsym) fprintf(out,"%s Circuit and excitation are symmetric about X axis.\n",comment);
  fprintf(out,"%s %c-Parameters, Magnitude/Angle, Matrix order",comment,toupper(Fmt->Param));
  if (Fmt->Cvend!='C' || Fmt->Param=='s') fprintf(out,", Normalized to 50 Ohms.\n");
  else                                    fprintf(out,".\n");

  /*Check for non-50-Ohm ports*/
  if (Fmt->Param=='s') for (i=0; i<C0->ports->m; i++)
  { rp = *(An->rp+i);
    xp = *(An->xp+i);
    lp = *(An->lp+i);
    cp = *(An->cp+i);
    if ( fabs(rp-50.0)+fabs(xp)+fabs(lp)+fabs(cp) > TINY )
    { fprintf(out,"Port %d normalized to",i+1);
      if (fabs(rp)>TINY) fprintf(out," %lf Ohms",rp);
      if (xp>TINY) fprintf(out," + j %lf Ohms",xp);
      if (xp< -TINY) fprintf(out," - j %lf Ohms",fabs(xp));
      if (lp>TINY) fprintf(out," + %lg Henries",lp);
      if (lp< -TINY) fprintf(out," %lg Henries",lp);
      if (cp>TINY) fprintf(out," + %lg Farads",cp);
      if (cp< -TINY) fprintf(out," %lg Farads",cp);
      fprintf(out,".\n");
    }
  }

  if (dbed)
  { fprintf(out,"%s AUTOMATIC DE-EMBEDDING IN EFFECT",comment);
    if ( Box->ref[0]>TINY || Box->ref[1]>TINY || Box->ref[2]>TINY || Box->ref[3]>TINY )
    {  fprintf(out,", Non-zero length reference planes:\n%s  ",comment);
      if ( Box->ref[0] > TINY )
         fprintf(out," left:%lf",Box->A * Box->ref[0] / (Box->Capm * Box->Lcnv));
      if ( Box->ref[1] > TINY )
         fprintf(out," right:%lf",Box->A * Box->ref[1] / (Box->Capm * Box->Lcnv));
      if ( Box->ref[2] > TINY )
        fprintf(out," top:%lf",Box->B * Box->ref[2] / (Box->Capn * Box->Lcnv));
      if ( Box->ref[3] > TINY )
        fprintf(out," bottom:%lf",Box->B * Box->ref[3] / (Box->Capn * Box->Lcnv));
      fprintf(out," (%s)",Box->Lstr);
    }
    else
      fprintf(out,", all reference planes are zero length.");
    fprintf(out,"\n");
  }

  if (Box->orphan)
  { fprintf(out,"%s *** WARNING: Circuit has metal with no subsections.\n",comment);
    fprintf(out,"%s              Check error message printed to 'stderr' (usually your CRT).\n",comment);
  }

  if (Box->rm_reson==1)
    fprintf(out,"%s Box resonance detection in effect.\n",comment);
  if (Box->rm_reson==2)
    fprintf(out,"%s Box resonance removal in effect.\n",comment);
  /*Put in vendor specific control line*/
  if (Fmt->Cvend == 'T') fprintf(out,"# %cHZ %c MA\n",An->Funit,toupper(Fmt->Param));
  if (Fmt->Cvend == 'C' && !dbed) fprintf(out,"%s: %c MP\n",ndbed_file,toupper(Fmt->Param));
  if (Fmt->Cvend == 'C' && dbed) fprintf(out,"%s: %c MP\n",dbed_file,toupper(Fmt->Param));
  if (Fmt->Cvend == 'H') fprintf(out,"name %s\nports %d\ndata %c mp\n",
				 Fmt->cir_name,
				 C0->ports->n,
				 Fmt->Param);
  fclose(out);
  return(0);
} /*Init_rsp_file*/

Do_ann( out,str_arr,num,com )  FILE *out;  char **str_arr,*com;  int num;
/*************************************************************/
/* Send ANN lines to out for each string in str_arr.         */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr01jan88 */ 
{ while( (num--)>0 ) fprintf(out,"%s-> %s\n",com,*(str_arr++));
  return(0);
} /*Do_ann*/

Out_timing( An,Fmt,stime )  An_info *An;  Fmt_info *Fmt; sTime *stime;
/*************************************************************/
/* Print out the timing information for first frequency.     */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/*jcr15dec92*/ 
{ FILE *out;

  comment = " ";
  if (An->State)
    Store_timing(stdout,stime,An->mode_calc_time,An->mat_fill_time,An->mat_solve_time);
  comment = Fmt->Com;

  /*Do the circuit response*/
  if (Fmt->dbed)
  { if ( (out=fopen(dbed_file,"a")) == NULL )
    { fprintf(stderr,"\n%s: Unable to open de-embedded data file -- %s --\n",
						    prog_name,dbed_file);
      return(-1);
    }
    Store_timing(out,stime,An->mode_calc_time,An->mat_fill_time,An->mat_solve_time);
    fclose(out);
  }

  if (Fmt->ndbed)
  { if ( (out=fopen(ndbed_file,"a")) == NULL )
    { fprintf(stderr,"\n%s: Unable to open non-de-embedded data file -- %s --\n",
						    prog_name,ndbed_file);
      return(-1);
    }
    Store_timing(out,stime,An->mode_calc_time,An->mat_fill_time,An->mat_solve_time);
    fclose(out);
  }

} /*Out_timing*/

Store_timing( out,stime,mode,fill,solve )  FILE *out;  sTime *stime;
					   int mode,fill,solve;
/*************************************************************/
/* Store the timing information for first frequency.         */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/*jcr15dec92*/ 
{ char *tstr;
  int started;

  tstr = TimeToString( stime);
  fprintf(out,"%s Analysis time per frequency (mm:ss) -- %s\n",comment,tstr);

  if ( mode+fill+solve > 0 )
  { started = 0;
    fprintf(out,"%s ",comment);

    if ( mode > 0 )
    { fprintf(out,"Modes = %d",mode);  started = 1; }

    if ( fill > 0 )
    { if (started) fprintf(out,", ");
      fprintf(out,"Fill = %d",fill);  started = 1;
    }

    if ( solve > 0 )
    { if (started) fprintf(out,", ");
      fprintf(out,"Solve = %d",solve);  started = 1;
    }

    fprintf(out," seconds.\n");
  }

} /*Store_timing*/

Out_reson(iside,te,tm,file_nr)  int iside,te[2*NUM_RES],tm[2*NUM_RES];  int file_nr;
/*************************************************************/
/* Output removed resonances, if any.                        */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29may87 */ 
{ FILE *out;
  int i;

  /*Check to see if any modes removed*/
  if (te[0]+te[1]+tm[0]+tm[1] == 0) return(0);

  if (file_nr == 0)  /*output to screen*/
    out = stdout;
  else if (file_nr == 1)  /*de-embedded file output*/
  { if ( (out=fopen(dbed_file,"a")) == NULL )
    { fprintf(stderr,"\n%s: Unable to open de-embedded data file -- %s --\n",
					     prog_name,dbed_file);
      return(-1);
    }
  }
  else if (file_nr == 2)  /*Not de-embedded file output*/
  {
    if ( (out=fopen(ndbed_file,"a")) == NULL )
    { fprintf(stderr,"\n%s: Unable to open non-de-embedded data file -- %s --\n",
					     prog_name,ndbed_file);
      return(-1);
    }
  }
  else return(0);

  /*Print out leader*/
  fprintf(out,"%s Box resonances, ",comment);
  if (iside==8) fprintf(out,"primary structure.\n");
  else if (iside<4) fprintf(out,"first standard, side %d.\n",iside);
  else fprintf(out,"second standard, side %d.\n",iside-4);

  fprintf(out,"%s",comment);
  /*Check for TE modes*/
  if (te[0]+te[1] > 0)
  { fprintf(out," TE:");
    for (i=0; i<3*NUM_RES; i+=3) if (te[i]+te[i+1] > 0)
      fprintf(out," %d(%d,%d,*)",te[i+2],te[i],te[i+1]);
    if (tm[0]+tm[1] > 0) fprintf(out,", ");
  }
  /*Check for TM modes*/
  if (tm[0]+tm[1] > 0)
  { fprintf(out," TM:");
    for (i=0; i<3*NUM_RES; i+=3) if (tm[i]+tm[i+1] > 0)
      fprintf(out," %d(%d,%d,*)",tm[i+2],tm[i],tm[i+1]);
  }
  fprintf(out,"\n");

  if ( file_nr != 0 ) fclose(out);

  return(0);

} /*Out_reson*/

Out_derror(iside,derror,file_nr)  int iside,file_nr;  Rtyp derror;
/*************************************************************/
/* Output de-embedding error to .d file, if big enough.      */
/* (C) COPYRIGHT 1993 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr19mar93 */ 
{ FILE *out;
  int i;

  /*Check to see if enough error*/
  if ( derror < 0.01 ) return(0);

  if ( file_nr == 0 )
    out = stderr;
  else if ( file_nr == 1 )  /*De-embedded data file*/
  { if ( (out=fopen(dbed_file,"a")) == NULL )
    { fprintf(stderr,"\n%s: Unable to open de-embedded data file -- %s --\n",
				     prog_name,dbed_file);
      return(-1);
    }
  }
  else return(0);

  derror = 100.0 * ( 1.0 - derror );

  fprintf(out,"%s\n%s ****WARNING**** Side %d de-embedding merit down to %3.1lf%%.\n",
    comment,comment,iside,derror);
  if (out == stderr) printf("\007");  /*Sound bell*/

  if ( file_nr != 0 ) fclose(out);

  return(0);

} /*Out_derror*/

Out_result( An,F,Fmt,Eeffp,Z0p )  An_info *An;  Rtyp F;  Fmt_info *Fmt;
				  complex *Eeffp,*Z0p;
/*************************************************************/
/* Do all the output for the electomagnic analysis.          */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29may87 */ 
{ FILE *out;

  comment = Fmt->Com;

  /*Do the circuit response file first*/
  if (Fmt->dbed)
  { if (An->State && An->cans->Num_row <= 4)  /*Output to screen*/
      Store_data(stdout,An,F,Fmt,1,Eeffp,Z0p);
    if ( (out=fopen(dbed_file,"a")) == NULL )
    { fprintf(stderr,"\n%s: Unable to open de-embedded data file -- %s --\n",
						    prog_name,dbed_file);
      return(-1);
    }
    Store_data(out,An,F,Fmt,1,Eeffp,Z0p);
    fclose(out);
  }

  if (Fmt->ndbed)
  { if (An->State && An->cans->Num_row <= 4)  /*Output to screen*/
      Store_data(stdout,An,F,Fmt,0,Eeffp,Z0p);
    if ( (out=fopen(ndbed_file,"a")) == NULL )
    { fprintf(stderr,"\n%s: Unable to open non-de-embedded data file -- %s --\n",
						    prog_name,ndbed_file);
      return(-1);
    }
    Store_data(out,An,F,Fmt,0,Eeffp,Z0p);
    fclose(out);
  }

  /*Do the jxy file next*/
  if (An->jxy)
  { if ( (out=fopen(Fmt->jxy_file,"a")) == NULL ) 
    { fprintf(stderr,"\n%s: Error opening output file, %s, for append.\n",
						    prog_name,Fmt->jxy_file);
      return(-1);
    }
    Store_jxy(out,An,F,Fmt,Eeffp,Z0p);
    fclose(out);
    Mat_close(An->jans);  An->jans = NULL;
  }

  /*Store the spice file*/
  if ( Fmt->spice )
  { if ( (out=fopen(Fmt->spice_file,"a")) == NULL ) 
    { fprintf(stderr,"\n%s: Error opening output file, %s, for append.\n",
						    prog_name,Fmt->spice_file);
      return(-1);
    }
    switch(Fmt->spice)
    { case 1 : store_spice2_data(out,An,F,Fmt);  break;
      case 2 : store_spice_data(out,An,F,Fmt);  break;
    }
    fclose(out);
  }

  if (An->cans) Mat_close(An->cans);  An->cans = NULL;
  if (An->uans) Mat_close(An->uans);  An->uans = NULL;

  return(0);

} /*Out_result*/

Store_data(out,An,F,Fmt,dbed,Eeffp,Z0p )  FILE *out;  An_info *An;  Rtyp F;
                                       Fmt_info *Fmt;  int dbed;
			               complex *Eeffp,*Z0p;
/*************************************************************/
/* Output all info in Result to an existing file.            */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr01jun87 */ 
/* jcr11feb88 take S-parameters in R0 */
{ int Item_count,Items_per_row,i,j;
  char Pfmt[20];
  Mat_ptr R;
/*Rtyp jcrR; / *diagnostic*/

  R = Mat_open(An->cans->Num_row,An->cans->Num_col);
  if (Fmt->dbed && !dbed)
    Mat_move(An->uans,R);
  else
    Mat_move(An->cans,R);

  if (Fmt->Param=='z') stoz(R);
  if (Fmt->Param=='y') stoy(R);
  /*Normalize to 50 Ohms if needed*/
  if (Fmt->Cvend!='C' && Fmt->Param == 'z') Mat_smult(0.02,0.0,R,R);
  if (Fmt->Cvend!='C' && Fmt->Param == 'y') Mat_smult(50.0,0.0,R,R);
  /*Normalize to non-50-Ohms if needed*/
  renorm_s(R,An->rp,An->xp,An->lp,An->cp,F);

  /*Always MHz for Sarnoff*/
  if (An->Funit == 'G' && Fmt->Cvend!='S')  F /= 1000.0;
  fmtr(Pfmt,11,F);
  if (Fmt->Cvend!='T' && Fmt->Cvend!='S')
  { if (An->Funit=='M')  strcat(Pfmt,"MHZ");
    else  strcat(Pfmt,"GHZ");
  }
  fprintf(out,"%s",Pfmt);
  Items_per_row = 4;
  if (R->Num_col == 3) Items_per_row = 3;
  if (R->Num_col == 1) Items_per_row = 1;
  for (i=0,Item_count=1; i<R->Num_col; i++)
  { for (j=0; j<R->Num_col; j++)
    { if ( (i|j) && Item_count==1 )
      { fprintf(out,"          ");
        if (Fmt->Cvend!='T') fprintf(out,"   ");
      }
      fmtr(Pfmt,9,Mat_get_mag(i,j,R));
      fprintf(out," %s",Pfmt);
      fmtr(Pfmt,7,Mat_get_deg(i,j,R));
      fprintf(out," %s",Pfmt);
      Item_count++;
      if ( Item_count>Items_per_row || (i+1 == R->Num_col && j+1 == R->Num_col) ) 
      { Item_count = 1;
        if (Fmt->Cvend == 'S' && ( i+1<R->Num_col || j+1<R->Num_col ) ) fprintf(out," &");
        fprintf(out,"\n");
      }
    }
    if (R->Num_col>4 && Fmt->Cvend == 'T')
    { fprintf(out,"\n\n");
      Item_count = 1;
    }
  }

/********* XXXXXX jcr Temp statements ***********/

/*jcrR = fabs(100.0 - Z0p->Re);
 *if (jcrR > 10.0) jcrR = 2.0 * fabs(50.0 - Z0p->Re);
 *if (jcrR > 10.0) jcrR = 4.0 * fabs(25.0 - Z0p->Re);
 *fprintf(out,"**** %lf Ohms, %lf degrees, %lf Eeff, %lf percent total error.\n",
 *	     Z0p->Re,Mat_get_deg(0,1,R),Eeffp->Re,jcrR+(90.0-fabs(Mat_get_deg(0,1,R)))/0.9);
 */

  /*Output the port imepdances and Eeff if de-embedding*/
  if (dbed) for (i=0; i<R->Num_col; i++,Eeffp++,Z0p++)
  { if (Z0p->Re>0.0) 
    { fprintf(out,"%s Eeff = (%6.2lf",Fmt->Com,Eeffp->Re);
      if (Eeffp->Im>1.0e-5) fprintf(out,"+j%8.5lf",Eeffp->Im);
      if (Eeffp->Im< -1.0e-5) fprintf(out,"-j%8.5lf",-Eeffp->Im);
      fprintf(out,"), Z0 = (%8.2lf",Z0p->Re);
      if (Z0p->Im>1.0e-5) fprintf(out,"+j%8.5lf",Z0p->Im);
      if (Z0p->Im< -1.0e-5) fprintf(out,"-j%8.5lf",-Z0p->Im);
      fprintf(out,").\n");
    }
    else fprintf(out,"%s Eeff = (  --  ), Z0 = (  --  ).\n",Fmt->Com);
  }

  Mat_close(R);

  fflush(out);
} /*Store_data*/

Init_jxy_file( argc,argv,Box,cir,An,Fmt ) int argc; char *argv[]; Box_info *Box;
				 Cir *cir;  An_info *An; Fmt_info *Fmt;
/*************************************************************/
/* Do all the jxy output                                     */
/* (C) COPYRIGHT 1991 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr10apr91 */ 
{ FILE *in,*out;
  int i;
  long clock=1;
  long time();
  char str[256],*ptr;
  msub_list *lev;
  msub *im;

  /*If file name ends in .jxy, try to make a backup*/
  ptr = Fmt->jxy_file + strlen( Fmt->jxy_file ) - 4;
  if ( !strcmp( ".jxy",ptr ) )
  { strncpy(str,Fmt->jxy_file,255);  /*Generate backup file name, .jxb*/
    str[ strlen(str) - 1 ] = 'b';  /* .jxy --> .jxb */
    rename(Fmt->jxy_file,str);  /*If jxy_file not there, nothing happens*/
  }

  if ( (out=fopen(Fmt->jxy_file,"w")) == NULL )
  { fprintf(stderr,"\n%s: Unable to open jxy response file -- %s --\n",
						       prog_name,Fmt->jxy_file);
    return(-1);
  }

  fprintf(out,"\nJHD ****New current distrubution section****\n");  /*Header section*/

  fprintf(out,"NAM %s\n",Box->file);

  fprintf(out,"CMD ");  /*Print command line*/
  for (i=0; i<argc; i++) fprintf(out,"%s ",argv[i]);
  fprintf(out,"\n");

  time(&clock);
  fprintf(out,"TIM %s",ctime(&clock));

  fprintf(out,"VER %s\n",get_version());
  if (An->Mem_saver) fprintf(out,"MEM\n");

  /*Now copy the .geo file*/
  fprintf(out,"GEO geometry file image follows.\n");
  if ( (in=fopen(Box->file,"r")) == NULL )
  { fprintf(stderr,"\n%s: Unable to open geometry file for copy to jxy file -- %s --\n",
						       prog_name,Box->file);
    fclose(out);
    return(-1);
  }

  while ( fgets(str,255,in) ) fprintf(out,"%s",str);

  fclose(in);

  /*Output subsection list*/

  for (lev=cir->lev0; lev<cir->lev0+cir->n; lev++) if (lev->n)
  { fprintf(out,"SUB %d %d\n",lev-cir->lev0,lev->n);
    for (im=lev->msub0; im<lev->msub0+lev->n; im++)
    { fprintf(out,"%d %d %d %d",im->loc,im->id,*im->ip,*(im->ip+1));
      if (im->id>=NUM_GSUB)
        fprintf(out," %d %d %d %d",*(im->ip+2),*(im->ip+3),*(im->ip+4),*(im->ip+5));
      fprintf(out,"\n");
    }
    fprintf(out,"END\n");
  }

  fprintf(out,"END\n");

  fflush(out);
  fclose(out);
  return(0);
} /*Init_jxy_file*/

Store_jxy(out,An,F,Fmt,Eeffp,Z0p )  FILE *out;  An_info *An;  Rtyp F;
                                       Fmt_info *Fmt;
			               complex *Eeffp,*Z0p;
/*************************************************************/
/* Output all jxy info.                                      */
/* (C) COPYRIGHT 1991 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr10apr91 */ 
{ int i,j;
  Mat_ptr R;

  R = (An->uans) ? An->uans : An->cans;

  /*Output Frequency first*/
  fprintf(out,"\nFRE %10e\n",F); /*MHz*/

  /*List out N-port S-parameters*/
  fprintf(out,"SPR\n");
  for (i=0; i<R->Num_row; i++) for (j=0; j<R->Num_col; j++)
    fprintf(out,"%8e %8e\n",Mat_get_re(i,j,R),Mat_get_im(i,j,R));
  fprintf(out,"END\n");

  /*Output the port imepdances and Eeff if de-embedding*/
  if (Fmt->dbed)
  { fprintf(out,"EFF\n");
    for (i=0; i<R->Num_col; i++,Eeffp++,Z0p++)
      fprintf(out,"%8e %8e %8e %8e\n",Eeffp->Re,Eeffp->Im,Z0p->Re,Z0p->Im);
    fprintf(out,"END\n");
  }

  /*Output the actual jxy data*/
  fprintf(out,"JXY\n");
  R = An->jans;
  if (R==NULL)
    announce_bug("Store_jxy(0)");
  for (i=0; i<R->Num_row; i++) for (j=0; j<R->Num_col; j++)
    fprintf(out,"%8e %8e\n",Mat_get_re(i,j,R),Mat_get_im(i,j,R));
  fprintf(out,"END\n");

  fflush(out);
} /*Store_jxy*/

init_spice_file( argc,argv,Box,C0,An,Fmt ) int argc; char *argv[]; Box_info *Box;
				 Cir *C0; An_info *An; Fmt_info *Fmt;
/*************************************************************/
/* Initialize the spice output file.                         */
/* (C) COPYRIGHT 1991 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr07aug91 */
/* Prototype version */
{ FILE *out;
  int i,sum;
  long clock=1;
  long time();
  char str[10];
  Met_type *Mp;
  Rtyp rp,xp,lp,cp;
  extern int print_license_warning;
  char *rsp_file;

  rsp_file = Fmt->spice_file;
  /*comment = Fmt->Com normally, but here...*/
  comment = "*";  /*Must be restored to Fmt->Com afterwards*/

  if ( (out=fopen(rsp_file,"a")) == NULL )
  { fprintf(stderr,"\n%s: Unable to open file for Spice LC data -- %s --\n",
						    prog_name,rsp_file);
    return(-1);
  }

  /*Output the command line*/
  fprintf(out,"\n%s **************************************************\n",comment);
  subsection_warning(out,Fmt->Com,print_license_warning);

  /*Do date and time next*/
  time(&clock);
  fprintf(out,"%s ",comment);
  for (i=0; i<argc; i++) fprintf(out,"%s ",argv[i]);
  fprintf(out,"-- %s",ctime(&clock));
  fprintf(out,"%s em %s, id %s, on %s.\n",
	      comment,get_version(),get_license_id(),get_node_id());
  fprintf(out,"%s Last time %s was updated - %s\n",comment,Box->file,Box->xgeomdate);
  Do_ann( out,Box->ann,Box->num_ann,comment );
  Do_ann( out,An->ann,An->num_ann,comment );
  if (An->Mem_saver) fprintf(out,"%s Memory saver option enabled.\n",comment);
  if ( sizeof(RRtyp) > sizeof(Rtyp) ) /*Check to make sure quad provides adavantage*/
  { if ( Box->quad_prec )
      fprintf(out,"%s Quad precision enabled.\n",comment);
    else if ( *An->Freq < Box->qfmin )
      fprintf(out,"%s Quad precision, '-q', automatically enabled below %.3lf MHz.\n",
        comment,Box->qfmin);
  }
  else if (Box->quad_prec)
    fprintf(out,"%s ***WARNING*** The '-q' option has no effect on this computer.\n",comment);
  fprintf(out,"%s At least %d subsections/wavelength.\n",comment,Box->msub_per);
  fprintf(out,"%s All dimensions are in %s.\n",comment,Box->Lstr);
  fprintf(out,"%s   A = %lf(%d), B = %lf(%d), C = %lf, with %d layers.\n",comment,
			     Box->A/Box->Lcnv,Box->Capm/2,Box->B/Box->Lcnv,Box->Capn/2,Box->C/Box->Lcnv,C0->n);
  fprintf(out,
    "%s   Layer  H(%5s)      Erel    tan(d)     Murel    tan(d)  subs\n"
    ,comment,Box->Lstr);
  sum = 0;
  for (i=0; i<=Box->Num_levels; i++)
  { fmtr(str,9,*(Box->H+i)/Box->Lcnv); fprintf(out,"%s     %d    %s",comment,i,str);
    fmtr(str,9,*(Box->Eps+i)/EPSILON_0);  fprintf(out,"  %s",str);
    fmtr(str,9,*(Box->Eloss+i));  fprintf(out,"  %s",str);
    fmtr(str,9,*(Box->Mu+i)/MU_0);  fprintf(out,"  %s",str);
    fmtr(str,9,*(Box->Mloss+i));  fprintf(out,"  %s",str);
    fprintf(out,"  %d\n",(C0->lev0+i)->n);
    sum += (C0->lev0+i)->n;
  }

  /*Do metalization losses*/
  if ( Box->num_met > 0 ||
       fabs(Box->Top.rdc)+fabs(Box->Top.rrf)+fabs(Box->Bot.rdc)+fabs(Box->Bot.rrf)+
            fabs(Box->Top.xdc)+fabs(Box->Bot.xdc) > 1.0e-30)
    fprintf(out,"%s Metalization Losses (Ohms/square)\n",comment);
  if (fabs(Box->Top.rdc)+fabs(Box->Top.rrf)+fabs(Box->Top.xdc) > 1.0e-30)
  { fprintf(out,"%s   %-12s --",comment,Box->Top.name);
    fprintf(out," %lg(DC)",Box->Top.rdc);
    fprintf(out,",%lg*sqrt(F)",Box->Top.rrf);
    if (Box->Top.xdc>1.0e-30) fprintf(out," + j %lg (DC)",Box->Top.xdc);
    if (Box->Top.xdc<1.0e-30) fprintf(out," - j %lg (DC)",fabs(Box->Top.xdc));
    fprintf(out,"\n");
  }
  if (fabs(Box->Bot.rdc)+fabs(Box->Bot.rrf)+fabs(Box->Bot.xdc) > 1.0e-30)
  { fprintf(out,"%s   %-12s --",comment,Box->Bot.name);
    fprintf(out," %lg(DC)",Box->Bot.rdc);
    fprintf(out,",%lg*sqrt(F)",Box->Bot.rrf);
    if (Box->Bot.xdc>1.0e-30) fprintf(out," + j %lg (DC)",Box->Bot.xdc);
    if (Box->Bot.xdc<1.0e-30) fprintf(out," - j %lg (DC)",-(Box->Bot.xdc));
    fprintf(out,"\n");
  }
  if (Box->num_met>0) for (Mp=Box->met; Mp<Box->met+Box->num_met; Mp++)
  { fprintf(out,"%s   %-12s --",comment,Mp->name);
    fprintf(out," %lg(DC)",Mp->rdc);
    fprintf(out,",%lg*sqrt(F)",Mp->rrf);
    if (Mp->xdc>1.0e-30) fprintf(out," + j %lg (DC)",Mp->xdc);
    if (Mp->xdc < -1.0e-30) fprintf(out," - j %lg (DC)",-(Mp->xdc));
    fprintf(out,"\n");
  }

  if (Box->Xsym) fprintf(out,"%s Circuit and excitation are symmetric about X axis.\n",comment);
  fprintf(out,"%s %c-Parameters, Magnitude/Angle, Matrix order",comment,toupper(Fmt->Param));
  if (Fmt->Cvend!='C' || Fmt->Param=='s') fprintf(out,", Normalized to 50 Ohms.\n");
  else                                    fprintf(out,".\n");

  /*Check for non-50-Ohm ports*/
  if (Fmt->Param=='s') for (i=0; i<C0->ports->m; i++)
  { rp = *(An->rp+i);
    xp = *(An->xp+i);
    lp = *(An->lp+i);
    cp = *(An->cp+i);
    if ( fabs(rp-50.0)+fabs(xp)+fabs(lp)+fabs(cp) > TINY )
    { fprintf(out,"Port %d normalized to",i+1);
      if (fabs(rp)>TINY) fprintf(out," %lf Ohms",rp);
      if (xp>TINY) fprintf(out," + j %lf Ohms",xp);
      if (xp< -TINY) fprintf(out," - j %lf Ohms",fabs(xp));
      if (lp>TINY) fprintf(out," + %lg Henries",lp);
      if (lp< -TINY) fprintf(out," %lg Henries",lp);
      if (cp>TINY) fprintf(out," + %lg Farads",cp);
      if (cp< -TINY) fprintf(out," %lg Farads",cp);
      fprintf(out,".\n");
    }
  }

  if (Fmt->dbed)
  { fprintf(out,"%s AUTOMATIC DE-EMBEDDING IN EFFECT",comment);
    if ( Box->ref[0]>TINY || Box->ref[1]>TINY || Box->ref[2]>TINY || Box->ref[3]>TINY )
    {  fprintf(out,", Non-zero length reference planes:\n%s  ",comment);
      if ( Box->ref[0] > TINY )
         fprintf(out," left:%lf",Box->A * Box->ref[0] / (Box->Capm * Box->Lcnv));
      if ( Box->ref[1] > TINY )
         fprintf(out," right:%lf",Box->A * Box->ref[1] / (Box->Capm * Box->Lcnv));
      if ( Box->ref[2] > TINY )
        fprintf(out," top:%lf",Box->B * Box->ref[2] / (Box->Capn * Box->Lcnv));
      if ( Box->ref[3] > TINY )
        fprintf(out," bottom:%lf",Box->B * Box->ref[3] / (Box->Capn * Box->Lcnv));
      fprintf(out," (%s)",Box->Lstr);
    }
    else
      fprintf(out,", all reference planes are zero length.");
    fprintf(out,"\n");
  }

  if (Box->rm_reson==1)
    fprintf(out,"%s Box resonance detection in effect.\n",comment);
  if (Box->rm_reson==2)
    fprintf(out,"%s Box resonance removal in effect.\n",comment);

  /*Output element value limits for lumped Spice model*/
  if ( Fmt->spice == 1 )
  { fprintf(out,"%s Limits: C>%lg pF, L<%lg nH, R<%lg Ohms, K>%lg",
      comment,An->cmin,An->lmax,An->rmax,An->mmin);
    if ( fabs(An->rzero) > TINY )
      fprintf(out,", Rzero=%lg Ohms",An->rzero);
    fprintf(out,".\n");
  }

  comment = Fmt->Com;  /*Restore original comment delimiter*/

  fclose(out);
  return(0);
} /*init_spice_file*/

store_spice_data(out,An,F,Fmt )  FILE *out;  An_info *An;  Rtyp F;
                                       Fmt_info *Fmt;
/*************************************************************/
/* Store Spice LC file.                                      */
/* (C) COPYRIGHT 1991 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr07aug91 */ 
{ Mat_ptr R,T;
  int icnt,ilim,nline,loss;
  int i,j;
  Rtyp winv,sum;

  nline = An->cans->Num_col;
  if (nline&1)
  { fprintf(out,"Even number of ports required.\n");
    fprintf(stderr,"\n%s: Even number of ports required for spice output.\n",prog_name);
    return;
  }
  nline = nline / 2;

  comment = "*";

  fprintf(out,".y1");
  for (i=0; i<nline; i++)
    fprintf(out," %d %d",i+1,i+1+nline);
  fprintf(out," 0 ymod l=1.0\n");
  fprintf(out,"%s Analysis frequency: %lf MHz\n",comment,F);
  fprintf(out,"%s *****Place terminations after this line.*****\n",comment);
  fprintf(out,".model ymod tra nlines=%d\n",nline);

  R = Mat_open(2*nline,2*nline);
  T = Mat_open(nline,nline);

  /*Calculate the L and R matrices*/
  Mat_move(An->cans,R);
  stoy(R);
  Mat_move(R,T);
  /*Check for resistive part*/
  for (i=0,loss=0; i<nline && !loss; i++) for (j=0; j<nline && !loss; j++)
    if (fabs(Mat_get_re(i,j,T)) > 1.0e-5) loss = 1;
  Mat_inv(T,0);
  /*Work the diagonal elements*/
  for (i=0; i<nline; i++)
  { for (j=0,sum=0.0; j<nline; j++)
      sum -= Mat_get_im(i,j,T);
    sum += 2.0 * Mat_get_im(i,i,T);
    Mat_put_im(i,i,sum,T);
    if (loss)
    { for (j=0,sum=0.0; j<nline; j++)
        sum -= Mat_get_re(i,j,T);
      sum += 2.0 * Mat_get_re(i,i,T);
      Mat_put_re(i,i,sum,T);
    }
  }

  /*Output the L matrix*/
  fprintf(out,"+ lmatrix=");
  icnt = 0;  ilim = 6; /*items per line*/
  winv =  1.0e9 / ( TWO_PI * 1.0e6 * F ); /*To get nH*/
  for (i=0; i<nline; i++) for (j=i; j<nline; j++)
  { if (j>0) fprintf(out,",");
    icnt++;
    if (icnt>ilim)
    { fprintf(out,"\n+ ");  icnt = 0; }
    fprintf(out,"%lfn",winv*Mat_get_im(i,j,T));
  }
  fprintf(out,"\n");

  /*Output the R matrix*/
  if (loss)
  { fprintf(out,"+ rmatrix=");
    icnt = 0;  ilim = 6; /*items per line*/
    for (i=0; i<nline; i++) for (j=i; j<nline; j++)
    { if (j>0) fprintf(out,",");
      icnt++;
      if (icnt>ilim)
      { fprintf(out,"\n");  icnt = 0; }
      fprintf(out,"%lf",Mat_get_re(i,j,T));
    }
    fprintf(out,"\n");
  }

  /*Calculate the C and G matrices*/
  Mat_move(An->cans,R);
  stoz(R);
  Mat_move(R,T);
  Mat_inv(T,0);
  /*Work the diagonal elements*/
  for (i=0; i<nline; i++)
  { for (j=0,sum=0.0; j<nline; j++)
      sum += Mat_get_im(i,j,T);
    Mat_put_im(i,i,sum,T);
    if (loss)
    { for (j=0,sum=0.0; j<nline; j++)
        sum += Mat_get_re(i,j,T);
      Mat_put_re(i,i,sum,T);
    }
  }

  /*Output the C matrix*/
  fprintf(out,"+ cmatrix=");
  icnt = 0;  ilim = 6; /*items per line*/
  winv =  1.0e12 / ( TWO_PI * 1.0e6 * F ); /*To get pF*/
  for (i=0; i<nline; i++) for (j=i; j<nline; j++)
  { if (j>0) fprintf(out,",");
    icnt++;
    if (icnt>ilim)
    { fprintf(out,"\n+ ");  icnt = 0; }
    fprintf(out,"%lfp",winv*Mat_get_im(i,j,T));
  }
  fprintf(out,"\n");

  /*Output the G matrix*/
  if (loss)
  { fprintf(out,"+ gmatrix=");
    icnt = 0;  ilim = 6; /*items per line*/
    for (i=0; i<nline; i++) for (j=i; j<nline; j++)
    { if (j>0) fprintf(out,",");
      icnt++;
      if (icnt>ilim)
      { fprintf(out,"\n");  icnt = 0; }
      fprintf(out,"%lf",Mat_get_re(i,j,T));
    }
    fprintf(out,"\n");
  }

  comment = Fmt->Com;  /*Restore original comment delimiter*/

  Mat_close(T);
  Mat_close(R);
} /*store_spice_data*/

#define LF_FMT_LEN 10

store_spice2_data(out,An,F,Fmt )  FILE *out;  An_info *An;  Rtyp F;
                                       Fmt_info *Fmt;
/*************************************************************/
/* Store a generic spice file.                               */
/* (C) COPYRIGHT 1991 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26aug91 */ 
{ static Mat_ptr cans0 = NULL;
  static Mat_ptr cans1 = NULL;
  static Rtyp w0 = 0.0;
  static Rtyp w1 = 0.0;
  Mat_ptr ind;  /*Used for inductance calculation*/
  Rtyp g0,b0,g1,b1,C0,L1,L2,L12,dif0,min_dif,val,limit;
  int nport,loss;
  int i,j,ii,jj,i0,i1,icnt,prec,internal_node;
  int *conn;  /*array to store connection info*/
  int nconn;
  char lf_fmt[LF_FMT_LEN];

  prec = Fmt->spice_prec;  /*Number of digits after decimal place*/
  if (prec<0) prec = 0;
  if (prec>7) prec = 7;
  limit = 0.5;
  for (i=0; i<prec; i++) limit *= 0.1;
  /*Build up format string for printing real number*/
  sprintf(lf_fmt," %d.%dlfpf\n",prec+2,prec);
  *lf_fmt = '%';
  if (strlen(lf_fmt)>LF_FMT_LEN)
    announce_bug("store_spice2_data");

  nport = An->cans->Num_col;
  if (cans0==NULL)
  { cans0 = Mat_open(nport,nport);
    Mat_move(An->cans,cans0);
    stoy(cans0);
    w0 = F;  /*To be converted to rad/sec later*/
    return;  /*Calculation of second frequency assummed*/
  }

  /*Second frequency info in An, get it*/
  cans1 = Mat_open(nport,nport);
  Mat_move(An->cans,cans1);
  stoy(cans1);
  ind = Mat_open(nport,nport);
  Mat_move(cans1,ind);
  w1 = F;

  if (cans0->Num_row != cans1->Num_row)
    announce_bug("store_spice2_data");

  comment = "*";

  fprintf(out,"%s Analysis frequencies: %lf, %lf MHz\n",comment,w0,w1);
  w0 = TWO_PI * 1000000.0 * w0;  /*radians/sec*/
  w1 = TWO_PI * 1000000.0 * w1;

  fprintf(out,".subckt %s",Fmt->cir_name);
  for (i=0; i<nport; i++)
    fprintf(out," %d",i+1);
  fprintf(out,"\n");

  /*Check for resistive part*/
  for (i=0,loss=0; i<nport && !loss; i++) for (j=0; j<nport && !loss; j++)
    if (fabs(Mat_get_re(i,j,cans1)) > 1.0e-5) loss = 1;

  /*Modify both cans so that only admittances to gnd left on diag*/
  for (i=0; i<nport; i++)
  { g0 = b0 = g1 = b1 = 0.0;
    for (j=0; j<nport; j++)
    { b0 += Mat_get_im(i,j,cans0);
      b1 += Mat_get_im(i,j,cans1);
    }
    if (loss) for (j=0; j<nport; j++)
    { g0 += Mat_get_re(i,j,cans0);
      g1 += Mat_get_re(i,j,cans1);
    }
    Mat_put(i,i,g0,b0,cans0);
    Mat_put(i,i,g1,b1,cans1);
  }

  /*Calculate capacitive lumped element model values*/
  icnt = 1;
  for (i=0; i<nport; i++) for (j=i; j<nport; j++)
  { b0 = Mat_get_im(i,j,cans0);
    b1 = Mat_get_im(i,j,cans1);
    C0 = ( b0*w0 - b1*w1 ) / ( w0*w0 - w1*w1 );
    if ( i==j && C0>0.0 )
    { val = C0 * 1.0e12;  /*pF*/
      if (fabs(val)>limit && fabs(val)>An->cmin)
      { fprintf(out,"C%d %d 0 ",icnt,i+1);
        fprintf(out,lf_fmt,val);
        icnt++;
      }
      /*Remove capacitance from ind matrix*/
      C0 *= w1;  /*Change cap to admittance*/
      Mat_put_im(i,i,Mat_get_im(i,i,ind)-C0,ind);
    }
    if ( i!=j && C0<0.0 )
    { val = - C0 * 1.0e12;  /*pF*/
      if (fabs(val)>limit && fabs(val)>An->cmin)
      { fprintf(out,"C%d %d %d ",icnt,i+1,j+1);
        fprintf(out,lf_fmt,val);
        icnt++;
      }
      /*Remove capacitance from ind matrix*/
      C0 *= w1;  /*Change cap to admittance*/
      Mat_put_im(i,i,Mat_get_im(i,i,ind)+C0,ind);
      Mat_put_im(i,j,Mat_get_im(i,j,ind)-C0,ind);
      Mat_put_im(j,i,Mat_get_im(j,i,ind)-C0,ind);
      Mat_put_im(j,j,Mat_get_im(j,j,ind)+C0,ind);
    }
  }

  /*Modify units of lf format string to no units*/
  *(lf_fmt+6) = '\n';
  *(lf_fmt+7) = '\000';

  /*Calculate conductive lumped element model values*/
  icnt = 1;
  if (loss) for (i=0; i<nport; i++) for (j=i; j<nport; j++)
  { g0 = Mat_get_re(i,j,cans0);
    g1 = Mat_get_re(i,j,cans1);
    g0 = ( g0*w0*w0 - g1*w1*w1 ) / ( w0*w0 - w1*w1 );
    if ( i==j )  /*Passive -> g0 > 0 */
    { if ( An->rmax > fabs(1.0/g0) )
      { fprintf(out,"R%d %d 0 ",icnt,i+1);
        fprintf(out,lf_fmt,1.0/g0);
        icnt++;
      }
      /*Remove conductance from ind matrix*/
      Mat_put_re(i,i,Mat_get_re(i,i,ind)-g0,ind);
    }
    if ( i!=j )  /*Passive -> g0 < 0 */
    { if ( An->rmax > fabs(1.0/g0) )
      { fprintf(out,"R%d %d %d ",icnt,i+1,j+1);
        fprintf(out,lf_fmt,-1.0/g0);
        icnt++;
      }
      /*Remove conductance from ind matrix*/
      Mat_put_re(i,i,Mat_get_re(i,i,ind)+g0,ind);
      Mat_put_re(i,j,Mat_get_re(i,j,ind)-g0,ind);
      Mat_put_re(j,i,Mat_get_re(j,i,ind)-g0,ind);
      Mat_put_re(j,j,Mat_get_re(j,j,ind)+g0,ind);
    }
  }

  /*Open array for storing connection information*/
  conn = (int *)cnew(2*nport*nport,sizeof(int));
  nconn = 0;

  /*Modify units of lf format string to nH*/
  *(lf_fmt+6) = 'n';
  *(lf_fmt+7) = 'h';

  /*Calculate self inductances*/
  internal_node = nport;  /*for series RL*/
  Mat_inv(ind,0);  /*ind is Z parameters of only inductors*/
  for (i=0; i<nport; i++)
  { min_dif = An->lmax * w1 * 1.0e-9;  /*Max inductor impedance of interest*/
    /*For each diff < min_dif, add a thru inductor*/
    dif0 = Mat_get_im(i,i,ind);
    g0 = Mat_get_re(i,i,ind); /*Is Ohms, not Mhos*/
    if ( fabs(dif0) < min_dif && fabs(g0) < An->rmax ) /*Ck inductance to ground*/
    { val = dif0 * 1.0e9 / w1;
      if ( fabs(An->rzero) < TINY && fabs(g0) < limit )
      { fprintf(out,"L%d %d 0 ",1+nconn/2,i+1);  /*Lossless inductor*/
        fprintf(out,lf_fmt,val);
      }
      else /*Series resitor needed*/
      { internal_node++;
        fprintf(out,"L%d %d %d ",1+nconn/2,i+1,internal_node);
        fprintf(out,lf_fmt,val);
        if ( fabs(g0) > limit )  /*Check for non-zero resistor*/
        { fprintf(out,"RL%d %d 0 ",1+nconn/2,internal_node);
          /*Modify units of lf format string to no units*/
          *(lf_fmt+6) = '\n';  *(lf_fmt+7) = '\000';
          fprintf(out,lf_fmt,g0);
          /*Modify units of lf format string back to nH*/
          *(lf_fmt+6) = 'n';  *(lf_fmt+7) = 'h';
        }
        else /*If actual resistor is zero, insert small resistor in series*/
        { fprintf(out,"RL%d %d 0 %lg\n",1+nconn/2,internal_node,An->rzero); }
      }
      *(conn+nconn) = i;
      *(conn+nconn+1) = i;  /* == previous value means ground*/
      nconn += 2;
    }
    for (j=i+1; j<nport; j++)
    { L1 = dif0 - Mat_get_im(i,j,ind) - Mat_get_im(j,i,ind) + Mat_get_im(j,j,ind);
      g0 = Mat_get_re(i,i,ind) - Mat_get_re(i,j,ind) - Mat_get_re(j,i,ind) + Mat_get_re(j,j,ind);
      if ( fabs(L1)<min_dif && fabs(g0) < An->rmax )
      { val = L1 * 1.0e9 / w1;
	if ( fabs(An->rzero) < TINY && fabs(g0) < limit )  /*Lossless inductor*/
        { fprintf(out,"L%d %d %d ",1+nconn/2,i+1,j+1);
          fprintf(out,lf_fmt,val);
        }
	else  /*Series resitor needed*/
	{ internal_node++;
          fprintf(out,"L%d %d %d ",1+nconn/2,i+1,internal_node);
          fprintf(out,lf_fmt,val);
	  if ( fabs(g0) > limit )  /*Check for non-zero resistor*/
          { fprintf(out,"RL%d %d %d ",1+nconn/2,internal_node,j+1);
            /*Modify units of lf format string to no units*/
            *(lf_fmt+6) = '\n';  *(lf_fmt+7) = '\000';
            fprintf(out,lf_fmt,g0);
            /*Modify units of lf format string back to nH*/
            *(lf_fmt+6) = 'n';  *(lf_fmt+7) = 'h';
	  }
          else /*If actual resistor is zero, insert small resistor in series*/
          { fprintf(out,"RL%d %d %d %lg\n",1+nconn/2,internal_node,j+1,An->rzero); }
        }
        *(conn+nconn) = i;
        *(conn+nconn+1) = j;
        nconn += 2;
      }
    }
  }

  /*Modify units of lf format string to no units*/
  *(lf_fmt+6) = '\n';
  *(lf_fmt+7) = '\000';

  /*Now calculate and save all the mutual inductances*/
  icnt = 1;
  for (i0=0; i0<nconn; i0 += 2)
  { i = *(conn+i0);
    j = *(conn+i0+1);
    L1 = Mat_get_im(i,i,ind);
    if (i!=j) L1 -= Mat_get_im(i,j,ind);
    if (i!=j) L1 -= Mat_get_im(j,i,ind);
    if (i!=j) L1 += Mat_get_im(j,j,ind);
    for (i1=i0+2; i1<nconn; i1 += 2)
    { ii = *(conn+i1);
      jj = *(conn+i1+1);
      L12 = Mat_get_im(i,ii,ind);
      if (ii!=jj) L12 -= Mat_get_im(i,jj,ind);
      if (i!=j && ii!=jj) L12 -= Mat_get_im(j,ii,ind);
      if (i!=j && ii!=jj) L12 += Mat_get_im(j,jj,ind);
      L2 = Mat_get_im(ii,ii,ind);
      if (ii!=jj) L2 -= Mat_get_im(ii,jj,ind);
      if (ii!=jj) L2 -= Mat_get_im(jj,ii,ind);
      if (ii!=jj) L2 += Mat_get_im(jj,jj,ind);
      L12 = L12 / sqrt( fabs(L1*L2) );
      if ( fabs(L12) >= limit && fabs(L12) > An->mmin )
      { if ( L1 < 0.0 )
          L12 = -L12;
        if ( L2 < 0.0 )
          L12 = -L12;
        if ( L12 > 1.0 )
          L12 = 1.0;
        if ( L12 < -1.0 )
          L12 = -1.0;
        fprintf(out,"K%d L%d L%d ",icnt,1+i0/2,1+i1/2);
        fprintf(out,lf_fmt,L12);
        icnt++;
      }
    }
  }

  fprintf(out,".ends %s\n",Fmt->cir_name);

  comment = Fmt->Com;  /*Restore original comment delimiter*/

  Mat_close(cans0);  cans0 = NULL;
  Mat_close(cans1);  cans1 = NULL;
  Mat_close(ind);  ind = NULL;
  sFree( (char *)conn);
  w0 = w1 = 0.0;

} /*store_spice2_data*/
